/*
    Electronic Candle
*/

#include <avr/io.h>
#include <avr/interrupt.h>

#define FOSC 8000000// Clock Speed


#define BLUE 2	//PB2
#define GREEN 3	//PB3
#define RED 4	//PB4


//Define functions
//======================
void delay_ms(uint16_t x);
void delay_us(uint8_t x);


int main (void)
{
	char a;
	int j;
	
	PORTB = 0;
	DDRB = 0b00011100;//PB2 = blue, PB3 = green, PB4 = red
	
	//setup timer0
	//TCCR0B = 2;//clk/8
	//TIMSK = 2;
	//sei();
	
	while(1)
	{
		//PORTB = 0b00010000;
		PORTB |= 1<<GREEN; //green on
		delay_ms(400);
		//for (j = 0; j < 250; j++);
		
		//while(1);
		
		//PORTB = 0;
		PORTB &= ~(1<<GREEN); //green off
		PORTB |= 1<<BLUE; //blue on
		//for (j = 0; j < 250; j++);
		delay_ms(400);
		
		//PORTB = 0;
		PORTB &= ~(1<<BLUE); //blue off
		PORTB |= 1<<RED; //red on
		//for (j = 0; j < 500; j++);
		delay_ms(400);
		//PORTB = 0;
		PORTB &= ~(1<<RED); //red off

	}
	
    
}


//General short delays, not terribly accurate
void delay_us(uint8_t x)
{
	int y;
	
	//TCNT0 = 256 - x; 
	//TIFR |= 0x02;//Clear any interrupt flags on Timer0
	
	//while(!(TIFR & 0x02));	
	
	
	for (y = 0; y < (100*x); y++);
	{
		asm volatile ("nop");
	}
		
	
}

//General short delays
void delay_ms(uint16_t x)
{
  uint8_t y, z;
  for ( ; x > 0 ; x--){
    for ( y = 0 ; y < 90 ; y++){
      for ( z = 0 ; z < 6 ; z++){
        asm volatile ("nop");
      }
    }
  }
}
